SimpleSelfRebuff:_rev("$Revision: 43056 $")

-------------------------------------------------------------------------------
-- Externals
-------------------------------------------------------------------------------

local SimpleSelfRebuff = SimpleSelfRebuff
local L = AceLibrary("AceLocale-2.2"):new("SimpleSelfRebuff")

-------------------------------------------------------------------------------
-- Locals
-------------------------------------------------------------------------------

local bindingButton
local TEH_BUTTON_NAME = "SimpleSelfRebuff_MouseWheelBindingButton"

-------------------------------------------------------------------------------
-- Module declaration
-------------------------------------------------------------------------------

local MouseWheelBinding = SimpleSelfRebuff:NewModule('MouseWheelBinding')

MouseWheelBinding.optionName = L["Mouse wheel bindings"]

function MouseWheelBinding:OnModuleEnable()
	self:RegisterEvent('SimpleSelfRebuff_PendingCastChanged', 'SetBinding')
	self:RegisterEvent('PLAYER_REGEN_DISABLED', 'SetBinding', false)
	self:RegisterEvent('PLAYER_REGEN_ENABLED', 'UpdateBinding')
	self:RegisterEvent('PLAYER_AURAS_CHANGED', 'UpdateBinding')
	self:UpdateBinding()
end

function MouseWheelBinding:OnModuleDisable()
	self:SetBinding(false)
end

function MouseWheelBinding:UpdateBinding()
	self:SetBinding(self.core:GetPendingCast())
end

function MouseWheelBinding:SetBinding(buff)

	if InCombatLockdown() then
		return
	elseif buff and not buff.mountFriendly and  (IsMounted() or IsStealthed()) then
		buff = nil
	end
	
	if buff then
		
		self.core:Debug('Binding mousewheel')
		
		if not bindingButton then
			bindingButton = CreateFrame("Button", TEH_BUTTON_NAME, UIParent, "SecureActionButtonTemplate")
			bindingButton:RegisterForClicks("LeftButtonUp")
			bindingButton:SetPoint("CENTER",0,0)
			bindingButton:Hide()
		end
		
		-- Reset attributes
		bindingButton:SetAttribute('type', nil)
		bindingButton:SetAttribute('spell', nil)			
		bindingButton:SetAttribute('unit', nil)			
		bindingButton:SetAttribute('target-slot', nil)			
		
		-- Setup attributes depending on source and target
		buff:SetupBuffSource(bindingButton)
		buff:SetupBuffTarget(bindingButton)
		
		-- Binding
		SetOverrideBindingClick(bindingButton, true, "MOUSEWHEELUP", TEH_BUTTON_NAME, "LeftButton")
		SetOverrideBindingClick(bindingButton, true, "MOUSEWHEELDOWN", TEH_BUTTON_NAME, "LeftButton")	
		
	elseif bindingButton then
		
		self.core:Debug('Unbinding mousewheel')
		ClearOverrideBindings(bindingButton)
		
	end

end
